{ Siro 22.04.2017 }
{ Horizontales Ausrichten mittels Programmcode }

unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    But_BAC: TButton;
    But_ABC: TButton;
    But_CBA: TButton;
    PanelA: TPanel;
    PanelB: TPanel;
    PanelC: TPanel;
    procedure But_ABCClick(Sender: TObject);
    procedure But_BACClick(Sender: TObject);
    procedure But_CBAClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }



procedure TForm1.FormCreate(Sender: TObject);
begin
  // Die rechte Kante von Panel A soll an der linken Kante von Panel B "kleben"

  PanelA.AnchorSide[akRight].Control:=PanelB;    // Ausrichten an Panel B
  PanelA.AnchorSide[akRight].Side   :=asrLeft;   // an der linken Kante von Panel B ausrichten,
  PanelA.Anchors := [akTop, akRight];            // selbst ausrichten an rechter Kante

// Die rechte Kante von Panel B soll an der linken Kante von Panel C "kleben"
  PanelB.AnchorSide[akRight].Control:=PanelC;    // Ausrichten an Panel C
  PanelB.AnchorSide[akRight].Side   :=asrLeft;   // an der linken Kante von Panel C ausrichten
  PanelB.Anchors:= [akTop,  akRight];            // selbst ausrichten an rechter Kante

// Panel C soll an der rechten Kante des Formulars "kleben"
  PanelC.AnchorSide[akRight].Control:=Form1;      // Ausrichten am Formular Rand
  PanelC.AnchorSide[akRight].Side   :=asrRight;   // am Formular ausrichten, rechte Kante
  PanelC.Anchors:= [akTop,  akRight];             // Eigene Kante: ausrichten an rechter Kante

// Die Funktionialiät, dass alle 3 Panels nebeneinander angeordnet sind und dann
// am rechten Rand des Formulars kleben ist damit gegeben.
// wird das Formular grösser, bleiben die Panels auch rechts am Formular.
// Die obere und untere Ausrichtung habe ich zwecks Übersichtlichkeit mal weggelassen :-)

end;

procedure TForm1.But_BACClick(Sender: TObject);
begin
  // Die rechte Kante von Panel A soll an der linken Kante von Panel C "kleben"
  PanelA.AnchorSide[akRight].Control:=PanelC;   // Ausrichten an Panel C
  PanelA.AnchorSide[akRight].Side:=asrLeft;

  // Die rechte Kante von Panel B soll an Panel A kleben
  PanelB.AnchorSide[akRight].Control:=PanelA;
  PanelB.AnchorSide[akRight].Side:=asrLeft;

  PanelC.AnchorSide[akRight].Control:=Form1;
  PanelC.AnchorSide[akRight].Side:=asrRight;
end;

procedure TForm1.But_CBAClick(Sender: TObject);
begin
  // Die rechte Kante von Panel A soll am Formular "kleben"
  PanelA.AnchorSide[akRight].Control:=Form1;
  PanelA.AnchorSide[akRight].Side   :=asrRight;   // am Formular ausrichten, rechte Kante

  // Die rechte Kante von Panel B soll an Panel A kleben
  PanelB.AnchorSide[akRight].Control:=PanelA;
  PanelB.AnchorSide[akRight].Side   :=asrLeft;

  // Die rechte Kante von Panel C soll an Panel B kleben
  PanelC.AnchorSide[akRight].Control:=PanelB;
  PanelC.AnchorSide[akRight].Side   :=asrLeft;

end;

procedure TForm1.But_ABCClick(Sender: TObject);
begin
  // Die rechte Kante von Panel A soll an der linken Kante von Panel B "kleben"
  PanelA.AnchorSide[akRight].Control:=PanelB;   // Ausrichten an Panel B
  PanelA.AnchorSide[akRight].Side   :=asrLeft;  // linke Seite von Panel B

  // Die rechte Kante von Panel B soll an Panel C kleben
  PanelB.AnchorSide[akRight].Control:=PanelC;   // Ausrichten an Panel C
  PanelB.AnchorSide[akRight].Side   :=asrLeft;   // linke Seite von Panel C

  // Die rechte Kante von Panel C soll am Formular kleben
  PanelC.AnchorSide[akRight].Control:=Form1;   // Ausrichten aam Formular
  PanelC.AnchorSide[akRight].Side   :=asrRight; //  rechte Seite vom Formular

end;

end.

